Index: /trunk/gsdl/macros/italian2.dm
===================================================================
--- /trunk/gsdl/macros/italian2.dm	(revision 7277)
+++ /trunk/gsdl/macros/italian2.dm	(revision 7278)
@@ -103,13 +103,13 @@
 
 ## "LA NEW ZEALAND DIGITAL LIBRARY" ## nzdl_heading ## nzdl2gr ##
-_httpiconnzdl_ [l=it] {_httpimg_/it/nzdl2gr.gif}
-_widthnzdl_ [l=it] {457}
-_heightnzdl_ [l=it] {181}
+_httpiconnzdl_ {_httpimg_/nzdl2gr.gif}
+_widthnzdl_ {457}
+_heightnzdl_ {181}
 
 ## "scegli una collezione" ## green_bar_left_aligned ## selcolgr ##
-_httpiconselcolgr_ [l=it] {_httpimg_/it/selcolgr.gif}
-_widthselcolgr_ [l=it] {537}
-_heightselcolgr_ [l=it] {17}
-_altselcolgr_ [l=it] {"Select a collection"}
+_httpiconselcolgr_ {_httpimg_/selcolgr.gif}
+_widthselcolgr_ {537}
+_heightselcolgr_ {17}
+_altselcolgr_ {"Select a collection"}
 
 
@@ -235,7 +235,7 @@
 
 ## "documentazione Greenstone" ## green_bar_left_aligned ## gsdocsgr ##
-_httpicongsdocsgr_ [l=it] {_httpimg_/it/gsdocsgr.gif}
-_widthgsdocsgr_ [l=it] {_pagewidth_}
-_heightgsdocsgr_ [l=it] {17}
+_httpicongsdocsgr_ {_httpimg_/gsdocsgr.gif}
+_widthgsdocsgr_ {_pagewidth_}
+_heightgsdocsgr_ {17}
 
 
@@ -447,5 +447,23 @@
 }
 
-# -- Missing translation: _textexptfail_
+_textexptfail_ [l=it] {<p>L'esportazione della collezione _cgiargbc1dirname_ Ãš fallita.
+
+<p>Probabilmente questo dipende dal fatto che Greenstone Ãš stato installato senza le componenti
+necessarie a supportare la funzione "Esporta collezione".
+<ul>
+
+ <li>Se hai installato Greenstone da un CD-ROM, queste componenti non sono state installate a meno che 
+ non le abbia selezionate durante l'installazione "Personalizzata".
+ Puoi aggiungerle alla tua installazione ripetendo la procedura di installazione.
+
+ <li>Se hai installato Greenstone da una distribuzion web, devi scaricare ed installare i pacchetti addizionali 
+ necessari ad abilitare questa funzione. Consulta <a href="http://www.greenstone.org">http://www.greenstone.org</a> 
+ oppure spedisci un'e-mail a <a
+ href="mailto:greenstone@cs.waikato.ac.nz">greenstone@cs.waikato.ac.nz</a>
+ per ulteriori informazioni.
+
+</ul>
+
+}
 
 #------------------------------------------------------------
@@ -454,48 +472,48 @@
 
 ## "Il collector" ## green_title ## h_colect ##
-_httpiconhcolect_ [l=it] {_httpimg_/it/h\_colect.gif}
+_httpiconhcolect_ {_httpimg_/h\_colect.gif}
 
 ## "informazioni\nsulla collezione" ## collector_bar_button ## info ##
-_httpicongcinfoof_ [l=it] {_httpimg_/it/gcinfoof.gif}
-_httpicongcinfoon_ [l=it] {_httpimg_/it/gcinfoon.gif}
-_httpiconycinfoof_ [l=it] {_httpimg_/it/ycinfoof.gif}
-_httpiconycinfoon_ [l=it] {_httpimg_/it/ycinfoon.gif}
-_httpiconncinfoof_ [l=it] {_httpimg_/it/ncinfoof.gif}
+_httpicongcinfoof_ {_httpimg_/gcinfoof.gif}
+_httpicongcinfoon_ {_httpimg_/gcinfoon.gif}
+_httpiconycinfoof_ {_httpimg_/ycinfoof.gif}
+_httpiconycinfoon_ {_httpimg_/ycinfoon.gif}
+_httpiconncinfoof_ {_httpimg_/ncinfoof.gif}
 
 ## "origine\ndei dati" ## collector_bar_button ## srce ##
-_httpicongcsrceof_ [l=it] {_httpimg_/it/gcsrceof.gif}
-_httpicongcsrceon_ [l=it] {_httpimg_/it/gcsrceon.gif}
-_httpiconycsrceof_ [l=it] {_httpimg_/it/ycsrceof.gif}
-_httpiconycsrceon_ [l=it] {_httpimg_/it/ycsrceon.gif}
-_httpiconncsrceof_ [l=it] {_httpimg_/it/ncsrceof.gif}
+_httpicongcsrceof_ {_httpimg_/gcsrceof.gif}
+_httpicongcsrceon_ {_httpimg_/gcsrceon.gif}
+_httpiconycsrceof_ {_httpimg_/ycsrceof.gif}
+_httpiconycsrceon_ {_httpimg_/ycsrceon.gif}
+_httpiconncsrceof_ {_httpimg_/ncsrceof.gif}
 
 ## "configura\nla collezione" ## collector_bar_button ## conf ##
-_httpicongcconfof_ [l=it] {_httpimg_/it/gcconfof.gif}
-_httpicongcconfon_ [l=it] {_httpimg_/it/gcconfon.gif}
-_httpiconycconfof_ [l=it] {_httpimg_/it/ycconfof.gif}
-_httpiconycconfon_ [l=it] {_httpimg_/it/ycconfon.gif}
-_httpiconncconfof_ [l=it] {_httpimg_/it/ncconfof.gif}
+_httpicongcconfof_ {_httpimg_/gcconfof.gif}
+_httpicongcconfon_ {_httpimg_/gcconfon.gif}
+_httpiconycconfof_ {_httpimg_/ycconfof.gif}
+_httpiconycconfon_ {_httpimg_/ycconfon.gif}
+_httpiconncconfof_ {_httpimg_/ncconfof.gif}
 
 ## "crea\nla collezione" ## collector_bar_button ## bild ##
-_httpicongcbildof_ [l=it] {_httpimg_/it/gcbildof.gif}
-_httpicongcbildon_ [l=it] {_httpimg_/it/gcbildon.gif}
-_httpiconycbildof_ [l=it] {_httpimg_/it/ycbildof.gif}
-_httpiconycbildon_ [l=it] {_httpimg_/it/ycbildon.gif}
-_httpiconncbildof_ [l=it] {_httpimg_/it/ncbildof.gif}
+_httpicongcbildof_ {_httpimg_/gcbildof.gif}
+_httpicongcbildon_ {_httpimg_/gcbildon.gif}
+_httpiconycbildof_ {_httpimg_/ycbildof.gif}
+_httpiconycbildon_ {_httpimg_/ycbildon.gif}
+_httpiconncbildof_ {_httpimg_/ncbildof.gif}
 
 ## "vedi\nla collezione" ## collector_bar_button ## view ##
-_httpicongcviewof_ [l=it] {_httpimg_/it/gcviewof.gif}
-_httpicongcviewon_ [l=it] {_httpimg_/it/gcviewon.gif}
-_httpiconycviewof_ [l=it] {_httpimg_/it/ycviewof.gif}
-_httpiconycviewon_ [l=it] {_httpimg_/it/ycviewon.gif}
-_httpiconncviewof_ [l=it] {_httpimg_/it/ncviewof.gif}
+_httpicongcviewof_ {_httpimg_/gcviewof.gif}
+_httpicongcviewon_ {_httpimg_/gcviewon.gif}
+_httpiconycviewof_ {_httpimg_/ycviewof.gif}
+_httpiconycviewon_ {_httpimg_/ycviewon.gif}
+_httpiconncviewof_ {_httpimg_/ncviewof.gif}
 
 ## "cancella\nla collezione" ## collector_bar_button ## del ##
-_httpicongcdelof_ [l=it] {_httpimg_/it/gcdelof.gif}
-_httpicongcdelon_ [l=it] {_httpimg_/it/gcdelon.gif}
+_httpicongcdelof_ {_httpimg_/gcdelof.gif}
+_httpicongcdelon_ {_httpimg_/gcdelon.gif}
 
 ## "esporta\nla collezione" ## collector_bar_button ## expt ##
-_httpicongcexptof_ [l=it] {_httpimg_/it/gcexptof.gif}
-_httpicongcexpton_ [l=it] {_httpimg_/it/gcexpton.gif}
+_httpicongcexptof_ {_httpimg_/gcexptof.gif}
+_httpicongcexpton_ {_httpimg_/gcexpton.gif}
 
 
@@ -566,7 +584,7 @@
 
 ## "informazioni sul software greenstone" ## green_bar_left_aligned ## abgsgr ##
-_httpiconabgsgr_ [l=it] {_httpimg_/it/abgsgr.gif}
-_widthabgsgr_ [l=it] {_pagewidth_}
-_heightabgsgr_ [l=it] {17}
+_httpiconabgsgr_ {_httpimg_/abgsgr.gif}
+_widthabgsgr_ {_pagewidth_}
+_heightabgsgr_ {17}
 
 
@@ -877,5 +895,5 @@
 
 ## "Interfaccia bibliotecario Greenstone" ## green_bar_left_aligned ## gligr ##
-_httpicongligr_ [l=it] {_httpimg_/it/gligr.gif}
-_widthgligr_ [l=it] {_pagewidth_}
-_heightgligr_ [l=it] {17}
+_httpicongligr_ {_httpimg_/gligr.gif}
+_widthgligr_ {_pagewidth_}
+_heightgligr_ {17}