Index: /trunk/gsdl/src/recpt/authenaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/authenaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/authenaction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_AUTHEN_ACTION
 
 #include "authenaction.h"
@@ -352,2 +355,4 @@
   return true;
 }
+
+#endif //GSDL_USE_AUTHEN_ACTION
Index: /trunk/gsdl/src/recpt/authenaction.h
===================================================================
--- /trunk/gsdl/src/recpt/authenaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/authenaction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_AUTHEN_ACTION
 
 #ifndef AUTHENACTION_H
@@ -79,4 +81,4 @@
 };
 
-
-#endif
+#endif //!AUTHENACTION_H
+#endif //GSDL_USE_AUTHEN_ACTION
Index: /trunk/gsdl/src/recpt/browseaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/browseaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/browseaction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_BROWSE_ACTION
 
 #include "browseaction.h"
@@ -243,6 +246,3 @@
 }
 
-
-
-
-
+#endif //GSDL_USE_BROWSE_ACTION
Index: /trunk/gsdl/src/recpt/browseaction.h
===================================================================
--- /trunk/gsdl/src/recpt/browseaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/browseaction.h	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_BROWSE_ACTION
 
 #ifndef BROWSEACTION_H
@@ -71,3 +74,4 @@
 };
 
-#endif
+#endif //!BROWSEACTION_H
+#endif //GSDL_USE_BROWSE_ACTION
Index: /trunk/gsdl/src/recpt/collectoraction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/collectoraction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/collectoraction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_COLLECTOR_ACTION
 
 // note that the collectoraction relies on having direct access to a
@@ -1977,2 +1980,4 @@
   return str;
 }
+
+#endif //GSDL_USE_COLLECTOR_ACTION
Index: /trunk/gsdl/src/recpt/collectoraction.h
===================================================================
--- /trunk/gsdl/src/recpt/collectoraction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/collectoraction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_COLLECTOR_ACTION
 
 #ifndef COLLECTORACTION_H
@@ -132,4 +134,4 @@
 };
 
-
-#endif
+#endif //!COLLECTORACTION_H
+#endif //GSDL_USE_COLLECTOR_ACTION
Index: /trunk/gsdl/src/recpt/converter.h
===================================================================
--- /trunk/gsdl/src/recpt/converter.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/converter.h	(revision 7371)
@@ -98,5 +98,5 @@
   size_type size() const {return converters.size();}
 
-  const_iterator find(text_t &key) {return converters.find(key);}
+  const_iterator find(const text_t &key) {return converters.find(key);}
 
   // added functionality
Index: /trunk/gsdl/src/recpt/extlinkaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/extlinkaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/extlinkaction.cpp	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_EXTLINK_ACTION
 
 #include <string.h>
@@ -250,2 +252,4 @@
   return true;
 }
+
+#endif //GSDL_USE_EXTLINK_ACTION
Index: /trunk/gsdl/src/recpt/extlinkaction.h
===================================================================
--- /trunk/gsdl/src/recpt/extlinkaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/extlinkaction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_EXTLINK_ACTION
 
 #ifndef EXTLINKACTION_H
@@ -58,5 +60,4 @@
 };
 
-
-
-#endif
+#endif //!EXTLINKACTION_H
+#endif //GSDL_USE_EXTLINK_ACTION
Index: /trunk/gsdl/src/recpt/gsdl_compatibility_cfg.h
===================================================================
--- /trunk/gsdl/src/recpt/gsdl_compatibility_cfg.h	(revision 7371)
+++ /trunk/gsdl/src/recpt/gsdl_compatibility_cfg.h	(revision 7371)
@@ -0,0 +1,38 @@
+#ifndef GSDL_COMPATIBILITY_CFG__H
+#define GSDL_COMPATIBILITY_CFG__H
+
+/**********************************************************************
+ *
+ * gsdl_compatibility_cfg.h -- 
+ * Copyright (C) 2004  The New Zealand Digital Library Project
+ *
+ * A component of the Greenstone digital library software
+ * from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *********************************************************************/
+
+//OLD NAME	NEW NAME
+#define __USE_MULTILANGUAGE_INTERFACE_         GSDL_USE_MULTILANGUAGE_INTERFACE
+#define GSDL_USE_GENERATOR_FEATURE             GSDL_USE_GENERATOR_ACTION
+#define GSDL_USE_EXPORT_FEATURE                GSDL_USE_EXPORT_ACTION
+#define __USE_CLASSIFIER_BROWSER_              GSDL_USE_CLASSIFIER_BROWSER
+#define GSDL_USE_CLONEBROWSERCLASS             GSDL_USE_CLONE_BROWSER
+#define __SOURCE_DIRECTORY_                    GSDL_SOURCE_DIRECTORY
+
+
+#endif //!GSDL_COMPATIBILITY_CFG__H
Index: /trunk/gsdl/src/recpt/gsdl_modules_cfg.h
===================================================================
--- /trunk/gsdl/src/recpt/gsdl_modules_cfg.h	(revision 7371)
+++ /trunk/gsdl/src/recpt/gsdl_modules_cfg.h	(revision 7371)
@@ -0,0 +1,85 @@
+#ifndef GSDL_MODULES_CFG__H
+#define GSDL_MODULES_CFG__H
+
+/**********************************************************************
+ *
+ * gsdl_modules_cfg.h -- 
+ * Copyright (C) 2004  The New Zealand Digital Library Project
+ *
+ * A component of the Greenstone digital library software
+ * from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *********************************************************************/
+
+// BASE CONFIG
+#define GSDL_USE_PER_COLLECTION_SETTINGS
+#define GSDL_SOURCE_DIRECTORY            "files"
+
+// FNORD CONFIG
+#define GSDL_USE_MULTILANGUAGE_INTERFACE
+
+//RECEPTIONIST CONFIG
+#define GSDL_USE_SESSIONS
+
+//QUERY CONFIG
+#define GSDL_USE_REMOVE_TAG_TERMS
+#undef  GSDL_USE_SAFEM_QUERY_FORMAT
+
+//DOCUMENT CONFIG
+// ONLY ONE GSDL_SKIP_* option can be enabled
+#define GSDL_SKIP_ONLY_EMPTY_DOC
+#undef  GSDL_SKIP_ALL_EMPTY_DOC_PARTS
+#undef  GSDL_USE_DOCUMENT_ASSOC_LANGS
+#define GSDL_USE_CL_SINGLE_DOCUMENT
+
+
+//ACTION MODULES
+#define GSDL_USE_AUTHEN_ACTION
+#define GSDL_USE_BROWSE_ACTION
+#undef  GSDL_USE_CL_DISPLAY_ACTION
+#define GSDL_USE_COLLECTOR_ACTION
+#undef  GSDL_USE_COURSES_ACTION
+#undef  GSDL_USE_DIR_BROWSE_ACTION
+#undef  GSDL_USE_EXPORT_ACTION
+#define GSDL_USE_EXTLINK_ACTION
+#undef  GSDL_USE_GENERATOR_ACTION
+#undef  GSDL_USE_INDEX_BROWSE_ACTION
+#define GSDL_USE_LANG_ACTION
+#define GSDL_USE_PHIND_ACTION
+#define GSDL_USE_PING_ACTION
+#define GSDL_USE_STATUS_ACTION
+#define GSDL_USE_TIP_ACTION
+
+//BROWSER MODULES
+#define GSDL_USE_CLASSIFIER_BROWSER
+#undef  GSDL_USE_TREE_EX_CLASSIFIER_BROWSER
+#undef  GSDL_USE_CLONE_BROWSER
+#undef  GSDL_USE_DATELIST_BROWSER
+#undef  GSDL_USE_HTML_BROWSER
+#undef  GSDL_USE_PAGED_BROWSER
+
+//FILTERS
+#undef  GSDL_USE_DIR_BROWSEFILTER
+
+//BROWSERS ADD-IN
+#define GSDL_USE_BY_BOOK_MACROS
+#undef  GSDL_USE_FLOAT_TOC
+
+#include "gsdl_compatibility_cfg.h"
+
+#endif //!GSDL_MODULES_CFG__H
Index: /trunk/gsdl/src/recpt/phindaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/phindaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/phindaction.cpp	(revision 7371)
@@ -25,4 +25,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_PHIND_ACTION
 
 // Note that this action uses mgpp to retrieve phind info, calling MGQuery
@@ -958,2 +961,4 @@
   }
 }
+
+#endif //GSDL_USE_PHIND_ACTION
Index: /trunk/gsdl/src/recpt/phindaction.h
===================================================================
--- /trunk/gsdl/src/recpt/phindaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/phindaction.h	(revision 7371)
@@ -1,5 +1,5 @@
 /**********************************************************************
  *
- * phindaction.cpp -- 
+ * phindaction.h -- 
  *
  * Copyright 2001 Gordon W. Paynter
@@ -25,4 +25,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_PHIND_ACTION
 
 #ifndef PHINDACTION_H
@@ -115,3 +118,4 @@
 };
 
-#endif
+#endif //!PHINDACTION_H
+#endif //GSDL_USE_PHIND_ACTION
Index: /trunk/gsdl/src/recpt/pingaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/pingaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/pingaction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_PING_ACTION
 
 #include "pingaction.h"
@@ -81,2 +84,4 @@
   return true;
 };
+
+#endif //GSDL_USE_PING_ACTION
Index: /trunk/gsdl/src/recpt/pingaction.h
===================================================================
--- /trunk/gsdl/src/recpt/pingaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/pingaction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_PING_ACTION
 
 #ifndef PINGACTION_H
@@ -50,3 +52,4 @@
 
 
-#endif
+#endif //!PINGACTION_H
+#endif //GSDL_USE_PING_ACTION
Index: /trunk/gsdl/src/recpt/statusaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/statusaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/statusaction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_STATUS_ACTION
 
 // following line required to get fstream.filedesc() on darwin (Mac OS X)
@@ -1129,2 +1132,4 @@
   }
 }
+
+#endif //GSDL_USE_STATUS_ACTION
Index: /trunk/gsdl/src/recpt/statusaction.h
===================================================================
--- /trunk/gsdl/src/recpt/statusaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/statusaction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_STATUS_ACTION
 
 #ifndef STATUSACTION_H
@@ -127,3 +129,4 @@
 
 
-#endif
+#endif //!STATUSACTION_H
+#endif //GSDL_USE_STATUS_ACTION
Index: /trunk/gsdl/src/recpt/tipaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/tipaction.cpp	(revision 7370)
+++ /trunk/gsdl/src/recpt/tipaction.cpp	(revision 7371)
@@ -23,4 +23,7 @@
  *
  *********************************************************************/
+
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_TIP_ACTION
 
 #include "tipaction.h"
@@ -67,2 +70,4 @@
   }
 }
+
+#endif //GSDL_USE_TIP_ACTION
Index: /trunk/gsdl/src/recpt/tipaction.h
===================================================================
--- /trunk/gsdl/src/recpt/tipaction.h	(revision 7370)
+++ /trunk/gsdl/src/recpt/tipaction.h	(revision 7371)
@@ -24,4 +24,6 @@
  *********************************************************************/
 
+#include "gsdl_modules_cfg.h"
+#ifdef GSDL_USE_TIP_ACTION
 
 #ifndef TIPACTION_H
@@ -44,3 +46,4 @@
 
 
-#endif
+#endif //!TIPACTION_H
+#endif //GSDL_USE_TIP_ACTION