Index: /trunk/gsdl3/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java
===================================================================
--- /trunk/gsdl3/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7451)
+++ /trunk/gsdl3/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7452)
@@ -50,8 +50,8 @@
     public native void addPass(char pass_type, char pass_num);
 
-    /** set the file paths */
-    public native void setPath(String filename);
-   /** set the file paths */
-    public native void setPaths(String base_path, String filename);
+    /** set the base path */
+    public native void setBasePath(String basepath);
+   /** set the file name */
+    public native void setFileName(String filename);
 
     public native void setStemOptions(String stemmer_type, int stem_method);
Index: /trunk/gsdl3/packages/mg/jni/MGPassesWrapperImpl.c
===================================================================
--- /trunk/gsdl3/packages/mg/jni/MGPassesWrapperImpl.c	(revision 7451)
+++ /trunk/gsdl3/packages/mg/jni/MGPassesWrapperImpl.c	(revision 7452)
@@ -52,7 +52,7 @@
 }
 
-/* Set the paths */
+/* Set the filename */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPath(JNIEnv *j_env, jobject j_obj,
+Java_org_greenstone_mg_MGPassesWrapper_setFileName(JNIEnv *j_env, jobject j_obj,
 						jstring j_filename)
 {
@@ -61,30 +61,26 @@
  
   assert(filename != NULL);
-  set_path(filename);
+  set_filename(filename);
   
-  /* Release the strings */
+  /* Release the string */
  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
 
-/* Set the paths */
+/* Set the base path */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPaths(JNIEnv *j_env, jobject j_obj,
-					  jstring j_basepath, jstring j_filename)
+Java_org_greenstone_mg_MGPassesWrapper_setBasePath(JNIEnv *j_env, 
+						   jobject j_obj,
+						   jstring j_basepath)
 {
   /* Get the base_path as a C string */
   const char* basepath = (*j_env)->GetStringUTFChars(j_env, j_basepath, NULL);
- /* Get the filename as a C string */
-   const char* filename = (*j_env)->GetStringUTFChars(j_env, j_filename, NULL);
- 
-  assert(filename != NULL);
   assert(basepath != NULL);
  
-  set_paths(basepath, filename);
+  set_basepath(basepath);
 
   
-  /* Release the strings */
+  /* Release the string */
   (*j_env)->ReleaseStringUTFChars(j_env, j_basepath, basepath);
-  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
Index: /trunk/gsdl3/packages/mg/src/text/gs3_mg_passes.c
===================================================================
--- /trunk/gsdl3/packages/mg/src/text/gs3_mg_passes.c	(revision 7451)
+++ /trunk/gsdl3/packages/mg/src/text/gs3_mg_passes.c	(revision 7452)
@@ -45,4 +45,7 @@
 /*
    $Log$
+   Revision 1.3  2004/05/26 04:38:42  kjdon
+   tidied up the setting filename and basepath path stuff
+
    Revision 1.2  2004/05/26 02:39:57  kjdon
    some hacky changes - fix up under linux
@@ -281,5 +284,5 @@
 }
 
-void set_path(char * filen) {
+void set_filename(char * filen) {
   int len = strlen(filen);
   if (filename) {
@@ -300,26 +303,5 @@
   
 }
-void set_paths(char * basep, char* filen) {
-  int len = strlen(filen);
-  if (filename) {
-    Xfree (filename);
-    filename = NULL;
-  }
-
-  filename = Xstrdup (filen);
-  set_basepath(basep);
-  // put this here for now
-  SkipSGML=0;
-  Dump=1;
-  trace = 512;
-  if (!trace_name)
-    trace_name = make_name (filename, TRACE_SUFFIX, NULL);
-  if (!(Trace = fopen (trace_name, "a")))
-    Message ("Unable to open \"%s\". No tracing will be done.", trace_name);
-  else
-    setbuf (Trace, NULL);
-  
-  
-}
+
 
 void add_pass (char pass_type, char pass_num) {
Index: /trunk/gsdl3/src/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java
===================================================================
--- /trunk/gsdl3/src/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7451)
+++ /trunk/gsdl3/src/packages/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7452)
@@ -50,8 +50,8 @@
     public native void addPass(char pass_type, char pass_num);
 
-    /** set the file paths */
-    public native void setPath(String filename);
-   /** set the file paths */
-    public native void setPaths(String base_path, String filename);
+    /** set the base path */
+    public native void setBasePath(String basepath);
+   /** set the file name */
+    public native void setFileName(String filename);
 
     public native void setStemOptions(String stemmer_type, int stem_method);
Index: /trunk/gsdl3/src/packages/mg/jni/MGPassesWrapperImpl.c
===================================================================
--- /trunk/gsdl3/src/packages/mg/jni/MGPassesWrapperImpl.c	(revision 7451)
+++ /trunk/gsdl3/src/packages/mg/jni/MGPassesWrapperImpl.c	(revision 7452)
@@ -52,7 +52,7 @@
 }
 
-/* Set the paths */
+/* Set the filename */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPath(JNIEnv *j_env, jobject j_obj,
+Java_org_greenstone_mg_MGPassesWrapper_setFileName(JNIEnv *j_env, jobject j_obj,
 						jstring j_filename)
 {
@@ -61,30 +61,26 @@
  
   assert(filename != NULL);
-  set_path(filename);
+  set_filename(filename);
   
-  /* Release the strings */
+  /* Release the string */
  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
 
-/* Set the paths */
+/* Set the base path */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPaths(JNIEnv *j_env, jobject j_obj,
-					  jstring j_basepath, jstring j_filename)
+Java_org_greenstone_mg_MGPassesWrapper_setBasePath(JNIEnv *j_env, 
+						   jobject j_obj,
+						   jstring j_basepath)
 {
   /* Get the base_path as a C string */
   const char* basepath = (*j_env)->GetStringUTFChars(j_env, j_basepath, NULL);
- /* Get the filename as a C string */
-   const char* filename = (*j_env)->GetStringUTFChars(j_env, j_filename, NULL);
- 
-  assert(filename != NULL);
   assert(basepath != NULL);
  
-  set_paths(basepath, filename);
+  set_basepath(basepath);
 
   
-  /* Release the strings */
+  /* Release the string */
   (*j_env)->ReleaseStringUTFChars(j_env, j_basepath, basepath);
-  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
Index: /trunk/gsdl3/src/packages/mg/src/text/gs3_mg_passes.c
===================================================================
--- /trunk/gsdl3/src/packages/mg/src/text/gs3_mg_passes.c	(revision 7451)
+++ /trunk/gsdl3/src/packages/mg/src/text/gs3_mg_passes.c	(revision 7452)
@@ -45,4 +45,7 @@
 /*
    $Log$
+   Revision 1.3  2004/05/26 04:38:42  kjdon
+   tidied up the setting filename and basepath path stuff
+
    Revision 1.2  2004/05/26 02:39:57  kjdon
    some hacky changes - fix up under linux
@@ -281,5 +284,5 @@
 }
 
-void set_path(char * filen) {
+void set_filename(char * filen) {
   int len = strlen(filen);
   if (filename) {
@@ -300,26 +303,5 @@
   
 }
-void set_paths(char * basep, char* filen) {
-  int len = strlen(filen);
-  if (filename) {
-    Xfree (filename);
-    filename = NULL;
-  }
-
-  filename = Xstrdup (filen);
-  set_basepath(basep);
-  // put this here for now
-  SkipSGML=0;
-  Dump=1;
-  trace = 512;
-  if (!trace_name)
-    trace_name = make_name (filename, TRACE_SUFFIX, NULL);
-  if (!(Trace = fopen (trace_name, "a")))
-    Message ("Unable to open \"%s\". No tracing will be done.", trace_name);
-  else
-    setbuf (Trace, NULL);
-  
-  
-}
+
 
 void add_pass (char pass_type, char pass_num) {
Index: /trunk/indexers/mg/java/org/greenstone/mg/MGPassesWrapper.java
===================================================================
--- /trunk/indexers/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7451)
+++ /trunk/indexers/mg/java/org/greenstone/mg/MGPassesWrapper.java	(revision 7452)
@@ -50,8 +50,8 @@
     public native void addPass(char pass_type, char pass_num);
 
-    /** set the file paths */
-    public native void setPath(String filename);
-   /** set the file paths */
-    public native void setPaths(String base_path, String filename);
+    /** set the base path */
+    public native void setBasePath(String basepath);
+   /** set the file name */
+    public native void setFileName(String filename);
 
     public native void setStemOptions(String stemmer_type, int stem_method);
Index: /trunk/indexers/mg/jni/MGPassesWrapperImpl.c
===================================================================
--- /trunk/indexers/mg/jni/MGPassesWrapperImpl.c	(revision 7451)
+++ /trunk/indexers/mg/jni/MGPassesWrapperImpl.c	(revision 7452)
@@ -52,7 +52,7 @@
 }
 
-/* Set the paths */
+/* Set the filename */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPath(JNIEnv *j_env, jobject j_obj,
+Java_org_greenstone_mg_MGPassesWrapper_setFileName(JNIEnv *j_env, jobject j_obj,
 						jstring j_filename)
 {
@@ -61,30 +61,26 @@
  
   assert(filename != NULL);
-  set_path(filename);
+  set_filename(filename);
   
-  /* Release the strings */
+  /* Release the string */
  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
 
-/* Set the paths */
+/* Set the base path */
 JNIEXPORT void JNICALL
-Java_org_greenstone_mg_MGPassesWrapper_setPaths(JNIEnv *j_env, jobject j_obj,
-					  jstring j_basepath, jstring j_filename)
+Java_org_greenstone_mg_MGPassesWrapper_setBasePath(JNIEnv *j_env, 
+						   jobject j_obj,
+						   jstring j_basepath)
 {
   /* Get the base_path as a C string */
   const char* basepath = (*j_env)->GetStringUTFChars(j_env, j_basepath, NULL);
- /* Get the filename as a C string */
-   const char* filename = (*j_env)->GetStringUTFChars(j_env, j_filename, NULL);
- 
-  assert(filename != NULL);
   assert(basepath != NULL);
  
-  set_paths(basepath, filename);
+  set_basepath(basepath);
 
   
-  /* Release the strings */
+  /* Release the string */
   (*j_env)->ReleaseStringUTFChars(j_env, j_basepath, basepath);
-  (*j_env)->ReleaseStringUTFChars(j_env, j_filename, filename);
 
 }
Index: /trunk/indexers/mg/src/text/gs3_mg_passes.c
===================================================================
--- /trunk/indexers/mg/src/text/gs3_mg_passes.c	(revision 7451)
+++ /trunk/indexers/mg/src/text/gs3_mg_passes.c	(revision 7452)
@@ -45,4 +45,7 @@
 /*
    $Log$
+   Revision 1.3  2004/05/26 04:38:42  kjdon
+   tidied up the setting filename and basepath path stuff
+
    Revision 1.2  2004/05/26 02:39:57  kjdon
    some hacky changes - fix up under linux
@@ -281,5 +284,5 @@
 }
 
-void set_path(char * filen) {
+void set_filename(char * filen) {
   int len = strlen(filen);
   if (filename) {
@@ -300,26 +303,5 @@
   
 }
-void set_paths(char * basep, char* filen) {
-  int len = strlen(filen);
-  if (filename) {
-    Xfree (filename);
-    filename = NULL;
-  }
-
-  filename = Xstrdup (filen);
-  set_basepath(basep);
-  // put this here for now
-  SkipSGML=0;
-  Dump=1;
-  trace = 512;
-  if (!trace_name)
-    trace_name = make_name (filename, TRACE_SUFFIX, NULL);
-  if (!(Trace = fopen (trace_name, "a")))
-    Message ("Unable to open \"%s\". No tracing will be done.", trace_name);
-  else
-    setbuf (Trace, NULL);
-  
-  
-}
+
 
 void add_pass (char pass_type, char pass_num) {