Index: /trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 7499)
+++ /trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 7500)
@@ -58,5 +58,4 @@
 import org.greenstone.gatherer.file.FileOpenActionListener;
 import org.greenstone.gatherer.gui.AboutDialog;
-//import org.greenstone.gatherer.gui.BrowsingPane;
 import org.greenstone.gatherer.gui.GatherPane;
 import org.greenstone.gatherer.gui.CreatePane;
@@ -68,5 +67,4 @@
 import org.greenstone.gatherer.gui.OpenCollectionDialog;
 import org.greenstone.gatherer.gui.Preferences;
-//import org.greenstone.gatherer.gui.PreviewPane;
 import org.greenstone.gatherer.gui.SimpleOpenCollectionDialog;
 import org.greenstone.gatherer.gui.metaaudit.MetaAuditFrame;
@@ -86,6 +84,4 @@
     extends JFrame
     implements ActionListener, ChangeListener {
-    /** The browsing pane behaves much like an internet browser, or at least will some day. */
-    //public BrowsingPane browser_pane = null;
     /** The mirror pane contains controls for mirroring internet sites. */
     public MirrorPane mirror_pane = null;
@@ -98,6 +94,4 @@
     /** The create pane contains scripting options for importing and building collections into libraries. */
     public CreatePane create_pane = null;
-    /** The preview pane contains a preview of your build collection. */
-    //public PreviewPane preview_pane = null;
 
     public FileOpenActionListener foa_listener = new FileOpenActionListener();
@@ -318,7 +312,4 @@
 	    new AboutDialog(this);
 	}
-//  	else if(esrc == menu_bar.help_browse) {
-//  	    help.setView("huntingforfiles");
-//  	}
 	else if(esrc == menu_bar.help_build) {
 	    help.setView("producingthecollection");
@@ -361,7 +352,4 @@
      */
     public void afterDisplay() {
-//  	if(Gatherer.config.get("workflow.browse", true)) {
-//  	    browser_pane.afterDisplay();
-//  	}
 	if (mirror_pane != null) {
 	    mirror_pane.afterDisplay();
@@ -390,5 +378,4 @@
 	design_pane.collectionChanged(ready); // Also important config pane is listening to latest msm.
 	create_pane.collectionChanged(ready); // Used to indicate a new BuildOptions model should be loaded.
-	//preview_pane.collectionChanged(ready); // preview should know when teh coll has changed so it can reload the home page
 
 	if(!locked) {
@@ -505,11 +492,4 @@
 		tab_pane.setEnabledAt(tab_pane.indexOfComponent(create_pane), false);
 	    }
-
-	    //preview_pane = new PreviewPane();
-	    //preview_pane.display();
-	    //if(Gatherer.config.get("workflow.preview", true)) {
-	    //tab_pane.addTab("GUI.Preview", Utility.getImage("final.gif"), preview_pane);
-	    //tab_pane.setEnabledAt(tab_pane.indexOfComponent(preview_pane), false);
-  	    //}
 
 	    // Select the collect pane if it is available
@@ -654,8 +634,4 @@
 	    // Some tabs are also dependant on if a collection is ready
 	    Component component = tab_pane.getComponentAt(index);
-  	    //if(component == preview_pane) {
-	    //tab_pane.setEnabledAt(index, state && Gatherer.c_man != null && Gatherer.c_man.ready() && Gatherer.c_man.built());
-  	    //}
-  	    //else 
 	    if(component == enrich_pane || component == design_pane || component == export_pane || component == create_pane) {
 		tab_pane.setEnabledAt(index, state && Gatherer.c_man != null && Gatherer.c_man.ready());
@@ -940,8 +916,4 @@
 	    mirror_pane.gainFocus();
 	}
-  	//else if(tab_pane.getSelectedIndex() == tab_pane.indexOfComponent(preview_pane)) {
-	//design_pane.saveConfiguration();
-	//preview_pane.gainFocus();
-  	//}
 
 	previous_pane = (JPanel) tab_pane.getSelectedComponent();
@@ -1023,38 +995,29 @@
 	}
     }
+
     private class TabUpdater
 	implements Runnable {
 	private boolean ready = false;
-	//private int browse_pos = -1;
 	private int mirror_pos = -1;
-	private int config_pos = -1;
+	private int enrich_pos = -1;
+	private int design_pos = -1;
 	private int create_pos = -1;
 	private int export_pos = -1;
-	private int metaedit_pos = -1;
-	//private int preview_pos = -1;
 	private JTabbedPane tab_pane = null;
+
 	public TabUpdater(JTabbedPane tab_pane, boolean ready) {
 	    this.ready = ready;
 	    this.tab_pane = tab_pane;
-	    //browse_pos = tab_pane.indexOfComponent(browser_pane);
 	    mirror_pos = tab_pane.indexOfComponent(mirror_pane);
-	    metaedit_pos = tab_pane.indexOfComponent(enrich_pane);
-	    config_pos = tab_pane.indexOfComponent(design_pane);
+	    enrich_pos = tab_pane.indexOfComponent(enrich_pane);
+	    design_pos = tab_pane.indexOfComponent(design_pane);
+	    create_pos = tab_pane.indexOfComponent(create_pane);
 	    export_pos = tab_pane.indexOfComponent(export_pane);
-	    create_pos = tab_pane.indexOfComponent(create_pane);
-	    //preview_pos = tab_pane.indexOfComponent(preview_pane);
-	}
-
-	public void run() {
-//  	    if(browse_pos != -1) {
-//  		if(ready) {
-//  		    tab_pane.setEnabledAt(browse_pos, Gatherer.config.get("workflow.browse", false));
-//  		}
-//  		else {
-//  		    tab_pane.setEnabledAt(browse_pos, Gatherer.config.get("workflow.browse", true));
-//  		}
-//  	    }
-	    if(mirror_pos != -1) {
-		if(ready) {
+	}
+
+	public void run()
+	{
+	    if (mirror_pos != -1) {
+		if (ready) {
 		    tab_pane.setEnabledAt(mirror_pos, Gatherer.config.get("workflow.mirror", false));
 		}
@@ -1063,20 +1026,18 @@
 		}
 	    }
-	    if(metaedit_pos != -1) {
-		tab_pane.setEnabledAt(metaedit_pos, ready && Gatherer.config.get("workflow.enrich", false));
-	    }
-	    if(config_pos != -1) {
-		tab_pane.setEnabledAt(config_pos, ready && Gatherer.config.get("workflow.design", false) && Gatherer.config.getMode() > Configuration.ASSISTANT_MODE);
-	    }
-	    if(export_pos != -1) {
+	    if (enrich_pos != -1) {
+		tab_pane.setEnabledAt(enrich_pos, ready && Gatherer.config.get("workflow.enrich", false));
+	    }
+	    if (design_pos != -1) {
+		tab_pane.setEnabledAt(design_pos, ready && Gatherer.config.get("workflow.design", false) && Gatherer.config.getMode() > Configuration.ASSISTANT_MODE);
+	    }
+	    if (create_pos != -1) {
+		tab_pane.setEnabledAt(create_pos, ready && Gatherer.config.get("workflow.create", false));
+	    }
+	    if (export_pos != -1) {
 		tab_pane.setEnabledAt(export_pos, ready && Gatherer.config.get("workflow.export", false));
 	    }
-	    if(create_pos != -1) {
-		tab_pane.setEnabledAt(create_pos, ready && Gatherer.config.get("workflow.create", false));
-	    }
-//  	    if(preview_pos != -1) {
-//  		tab_pane.setEnabledAt(preview_pos, Gatherer.c_man != null && Gatherer.c_man.built() && Gatherer.config.get("workflow.preview", false));
-//  	    }
-	}
+	}
+
 	public void setReady(boolean ready) {
 	    this.ready = ready;